option casemap:none
include mineiro.inc
library macro nome_biblioteca:REQ
	IFNB <@CurSeg>
		includelib <&nome_biblioteca.lib>
;		includelib <\masm64\lib\&nome_biblioteca.lib>
	ENDIF
endm
function macro nome_funcao:REQ
;nome TEXTEQU <__imp_&nome_funcao>
;EXTERNDEF nome:
EXTERNDEF nome_funcao: PROTO
endm

library kernel32
	function GetModuleHandleA
	function GetCommandLineA
	function ExitProcess
	
library user32
	function LoadIconA
	function LoadCursorA
	function RegisterClassExA
	function CreateWindowExA
	function ShowWindow
	function UpdateWindow
	function TranslateMessage
	function PostQuitMessage
	function BeginPaint
	function EndPaint
	function GetClientRect
	function InvalidateRect
	function GetMessageA
	function DispatchMessageA
	function DefWindowProcA
	
library gdi32
	function SelectObject
	function SetTextColor
	function SetBkColor
	function DrawTextA
	function CreateFontA
	function TextOutA

.data?
manipulador_instancia dq	?
ptr_linha_comando	dq	?

.data
mineiro_classe db "Mineiro",00h
nome_aplicativo  db "Windows Test",00h
texto	db	"press a key ",00h
TestString  db "Win64 assembly is cool!",0 
FontName db "script",0 
char dq 20h

.code

align 16
Inicio proc 
	and rsp,-10h
	xor rcx,rcx
	sub rsp,4*8
	call GetModuleHandleA
	add rsp,4*8
	mov manipulador_instancia,rax
	call GetCommandLineA
	mov ptr_linha_comando,rax
	mov r9,SW_SHOWDEFAULT
	mov r8,ptr_linha_comando
	mov rdx,0
	mov rcx,manipulador_instancia
	sub rsp,4*8
	call Janela_principal
	add rsp,4*8
	mov rcx,rax
	sub rsp,4*8
	call ExitProcess
	add rsp,4*8
	ret
Inicio endp

align 16
Janela_principal proc hInst:QWORD,hPrevInst:QWORD,CmdLine:QWORD,CmdShow:QWORD
	LOCAL MENSAGEM:MSG
	LOCAL wc:WNDCLASSEX
	LOCAL hwnd:QWORD
	
	and rsp,-10h
	mov hInst,rcx
	mov hPrevInst,rdx
	mov CmdLine,r8
	mov CmdShow,r9
	
	mov rdx,IDI_APPLICATION
	mov rcx,0
	sub rsp,4*8
	call LoadIconA
	add rsp,4*8
	mov	wc.hIcon,rax
	mov wc.hIconSm,rax
	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	lea	rax,Procedimento_janela
	mov wc.lpfnWndProc,rax
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov	rax,hInst
	mov wc.hInstance,rax
	
	mov rdx,IDC_ARROW
	mov rcx,0
	sub rsp,4*8
	call LoadCursorA
	add rsp,4*8
	mov wc.hCursor,rax
	mov wc.hbrBackground,COLOR_WINDOW+1
	mov wc.lpszMenuName,0
	mov	rax,offset mineiro_classe
	mov wc.lpszClassName,rax
	
	lea rcx,wc
	sub rsp,4*8
	call RegisterClassExA
	add rsp,4*8

	push 0
	push hInst
	push 0
	push 0
	push 460
	push 460
	push 0
	push 0
	mov r9,WS_OVERLAPPEDWINDOW
	lea r8,nome_aplicativo
	lea rdx,mineiro_classe
	mov rcx,WS_EX_APPWINDOW
	sub rsp,4*8
	call CreateWindowExA
	add rsp,4*8
	
	mov hwnd,rax

	mov rdx,SW_SHOWDEFAULT
	mov rcx,hwnd
	sub rsp,4*8
	call ShowWindow
	add rsp,4*8

	mov rcx,hwnd
	sub rsp,4*8
	call UpdateWindow
	add rsp,4*8

	
MSG_LOOP:
	mov r9,0
	mov r8,0
	mov rdx,0
	lea rcx,MENSAGEM
	sub rsp,4*8
	call GetMessageA
	add rsp,4*8
	cmp rax,1
	jb END_LOOP
	lea rcx,MENSAGEM
	sub rsp,4*8
	call TranslateMessage
	add rsp,4*8

	lea rcx,MENSAGEM
	sub  rsp,4*8
	call DispatchMessageA
	add rsp,4*8
	jmp MSG_LOOP
END_LOOP:
	mov rax,MENSAGEM.wParam
	ret
Janela_principal endp

align 16
Procedimento_janela proc Wnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
LOCAL	ps:PAINTSTRUCT
LOCAL	hdc:HANDLE
LOCAL	hfonte:HANDLE
LOCAL	rect:RECT

	and rsp,-10h
	
	mov	Wnd,rcx
	mov	uMsg,rdx
	mov	wParam,r8
	mov	lParam,r9
	cmp	edx,WM_DESTROY
	je	DESTROY
	cmp edx,WM_PAINT
	je PAINT
	cmp edx,WM_CHAR
	je KEYBOARD
	sub rsp,4*8
	call DefWindowProcA
	add rsp,4*8
	ret

PAINT:
	lea rdx,ps
	mov rcx,Wnd
	sub rsp,4*8
	call BeginPaint
	add rsp,4*8
	mov hdc,rax
	
	push 1
	lea r9,char
	mov r8,100
	mov rdx,100
	mov rcx,hdc
	sub rsp,4*8
	call TextOutA
	add rsp,4*8

	lea rdx,rect
	mov rcx,Wnd
	sub rsp,4*8
	call GetClientRect
	add rsp,4*8

	push DT_CENTER or DT_VCENTER or DT_SINGLELINE
	lea r9,rect
	mov r8,-1
	lea rdx,texto
	mov rcx,hdc
	sub rsp,4*8
	call DrawTextA
	add rsp,4*8
	
	lea rax,FontName
	push rax
	push DEFAULT_PITCH or FF_SCRIPT
	push DEFAULT_QUALITY
	push CLIP_DEFAULT_PRECIS
	push OUT_DEFAULT_PRECIS
	push OEM_CHARSET
	push 0
	push 0
	push 0
	push 400
	mov r9,0
	mov r8,0
	mov rdx,16
	mov rcx,24
	sub rsp,4*8
	call CreateFontA
	add rsp,4*8

	mov rdx,rax
	mov rcx,hdc
	sub rsp,4*8
	call SelectObject
	add rsp,4*8
	
	mov rdx,0f0f0fh
	mov rcx,hdc
	sub rsp,4*8
	call SetTextColor
	add rsp,4*8

	mov rdx,0f0f0f0h
	mov rcx,hdc
	sub rsp,4*8
	call SetBkColor
	add rsp,4*8

	push sizeof TestString-1
	lea r9,TestString
	mov r8,0
	mov rdx,0
	mov rcx,hdc
	sub rsp,4*8
	call TextOutA
	add rsp,4*8

	mov rdx,hfonte
	mov rcx,hdc
	sub rsp,4*8
	call SelectObject
	add rsp,4*8

	lea rdx,ps
	mov rcx,Wnd
	sub rsp,4*8
	call EndPaint
	add rsp,4*8
	jmp fim

KEYBOARD:
	push wParam
	pop char
	mov r8,1
	mov rdx,0
	mov rcx,Wnd
	sub rsp,4*8
	call InvalidateRect
	add rsp,4*8
	jmp fim

DESTROY:
	xor rcx,rcx
	sub rsp,4*8
	call PostQuitMessage
	add rsp,4*8
	jmp	fim
fim:
	xor	rax,rax
	ret
Procedimento_janela endp

ALIAS <mainCRTStartup>=<Inicio>		;;console
ALIAS <WinMainCRTStartup>=<Inicio>	;;windows
END
